package
{
	import flash.geom.Point;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.Sfx;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import net.flashpunk.graphics.Spritemap;
	
	// gamer is a classs fo a game entity, controlled either
	// by local player, remote player or AI or nothing
	public class Player extends Gamer
	{
		[Embed(source='gfx/santa.png')]
		protected var TILES:Class;
		
		[Embed(source='gfx/chomp.mp3')]
		protected var CHOMP:Class;
		
		public var chomp:Sfx = new Sfx(CHOMP);
		
		public var sprite:Spritemap = new Spritemap(TILES, 48, 48);
		
		public function Player(x:Number,y:Number)
		{
			
			sprite.originX = 16;
			sprite.originY = 16;
			sprite.add("idle", [0, 1], .10);
			sprite.add("run", [2, 3], .20);
			sprite.add("jump", [4, 5], .20);
			setHitbox(32,32);
			graphic = sprite;
			super(x, y);
		}

		override public function input():uint 
		{
			var ret:uint = 0;
			if (Input.check(Key.UP)) ret|=UP;
			if (Input.check(Key.DOWN)) ret|=DOWN;
			if (Input.check(Key.LEFT)) { ret |= LEFT; sprite.flipped = true;}
			if (Input.check(Key.RIGHT)) {ret |= RIGHT; sprite.flipped = false;}
			if (Input.pressed(Key.SPACE)) ret |= JUMP;
			if (Input.check(Key.SPACE)) ret |= MULTIJUMP;
			if (!(Math.abs(vy) > 1))
				if (ret) sprite.play("run"); else sprite.play("idle");
			return ret;
		}
		
		override public function update():void
		{
			super.update();
			FP.camera.x = x - FP.halfWidth;
			FP.camera.y = y - FP.halfWidth;
			if (Math.abs(vy) > 1) sprite.play("jump");
			var e:Entity = collide("food", x, y);
			if (e)
			{
				FP.world.remove(e);
				for (var c:uint = 0; c < 15; c++) FP.world.add(new Blood(e.x, e.y));
				Levelworld.score += 100;
				Food.food += .02;
				(new Sfx(CHOMP)).play();
			}
			
		}
		
	}
}